package eu.mhsl.craftattack.spawn.api.client.repositories;

import eu.mhsl.craftattack.spawn.api.client.HttpRepository;
import eu.mhsl.craftattack.spawn.api.client.ReqResp;
import eu.mhsl.craftattack.spawn.util.api.ApiUtil;

import java.util.UUID;

public class WhitelistRepository extends HttpRepository {
    public WhitelistRepository() {
        super(ApiUtil.getBaseUri(), ApiUtil::withAuthorizationSecret);
    }

    public record UserData(
        UUID uuid,
        String username,
        String firstname,
        String lastname,
        Long banned_until,
        Long outlawed_until
    ) {
    }

    public ReqResp<UserData> getUserData(UUID userId) {
        return this.get(
            "user",
            parameters -> parameters.addParameter("uuid", userId.toString()),
            UserData.class
        );
    }
}
