package eu.mhsl.craftattack.spawn.appliances.endPrevent;

import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Map;

public class EndPreventCommand extends ApplianceCommand<EndPrevent> {
    private final Map<String, Boolean> arguments = Map.of("preventEnd", true, "allowEnd", false);

    public EndPreventCommand() {
        super("endPrevent");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length == 1 && arguments.containsKey(args[0])) {
            getAppliance().setEndDisabled(arguments.get(args[0]));
            sender.sendMessage(Component.text("Setting updated!", NamedTextColor.GREEN));
        }
        sender.sendMessage(Component.text(
            String.format("The End is %s!", getAppliance().isEndDisabled() ? "open" : "closed"),
            NamedTextColor.GOLD
        ));
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        return arguments.keySet().stream().toList();
    }
}
